package com.assignment;

import com.assignment.util.Student;

import java.util.Arrays;
import java.util.List;

public class Java8ForEachExample {

    //forEach() method is used to iterate the elements defined in the iterable and stream interface.
    //syntax -     default void forEach(Consumer<super T>action)

    //method #2
    private static void iterateCollection() {
        final List<String> names = Arrays.asList("John", "Adam", "Patrick", "Melisandre", "Sansa", "Daenerys");

        System.out.println("------------Iterating by passing method reference---------------");
        names
                .stream()
                .forEach(System.out::println);  //printing the results
    }

    //method #2
    private static void iterateStudentCollection() {
        System.out.println("------------Iterating by passing lambda expression--------------");
        Student.createStudents()
                .stream()
                .forEach(student -> System.out.println(student.toString()));    //printing the results
    }

    public static void main(String[] args) {
        iterateCollection();
        iterateStudentCollection();
    }
}
